<div class="card bg-dark text-white">
    <div class="card-header">{{title}}</div>
    <div class="card-body">
        <form #bookForm="ngForm">
            <div class="form-group row">
                <label for="name" class="col-form-label col-sm-2">Title</label>
                <div class="col-sm-10">
                    <input type="text" [(ngModel)]="book.name" placeholder="Title of the book" class="form-control" id="name" name="name" required #name="ngModel">
                    <div class="alert alert-danger" *ngIf="name.invalid && (name.dirty || name.touched)">
                        <div *ngIf="name.errors.required">
                            Title is required
                        </div>
                    </div>
                </div>
            </div>
            <div class="form-group row">
                <label for="author" class="col-form-label col-sm-2">Author</label>
                <div class="col-sm-10">
                    <input type="text" [(ngModel)]="book.author" placeholder="Author of the book" class="form-control" id="author" name="author" required #author="ngModel">
                    <div class="alert alert-danger" *ngIf="author.invalid && (author.dirty || author.touched)">
                        <div *ngIf="author.errors.required">
                            Author is required
                        </div>
                    </div>
                </div>
            </div>
            <div class="form-group row">
                <label for="genre" class="col-form-label col-sm-2">Genre</label>
                <div class="col-sm-10">
                    <input type="text" [(ngModel)]="book.genre" placeholder="Genre of the book" class="form-control" id="genre" name="genre">
                </div>
            </div>
            <div class="form-group row">
                <label for="publisher" class="col-form-label col-sm-2">Publisher</label>
                <div class="col-sm-10">
                    <input type="text" [(ngModel)]="book.publisher" placeholder="Publisher of the book" class="form-control" id="publisher" name="publisher">
                </div>
            </div>
            <div class="form-group row">
                <label for="publishedYear" class="col-form-label col-sm-2">Published Year</label>
                <div class="col-sm-10">
                    <input type="text" [(ngModel)]="book.publishedYear" placeholder="Published Year of the book" class="form-control" id="publishedYear"
                        name="publishedYear" digitOnly min="1800" max="2155" maxlength="4" pattern="^(18\d\d|19\d\d|20\d\d|2[0-1][0-4][0-9]|215[0-5])$" #publishedYear="ngModel">
                    <div class="alert alert-danger" *ngIf="publishedYear.invalid && (publishedYear.dirty || publishedYear.touched)">
                        <div *ngIf="publishedYear.errors.pattern">
                            Year must be between 1800 and 2155
                        </div>
                    </div>
                </div>
            </div>
            <div class="form-group row">
                <div class="col-sm-12">
                    <ng-container *ngIf="!book.id else elseTemplate">
                        <button (click)="addBook()" class="btn btn-primary btn-lg float-right" [disabled]="!bookForm.form.valid">Add</button>
                    </ng-container>
                    <ng-template #elseTemplate>
                        <button (click)="updateBook()" class="btn btn-primary btn-lg float-right" [disabled]="!bookForm.form.valid">Update</button>
                    </ng-template>
                </div>
            </div>
        </form>
    </div>
</div>